diff --git a/sql/item_geofunc.h b/sql/item_geofunc.h
index cbd37fc..838f0b2 100644
--- a/sql/item_geofunc.h
+++ b/sql/item_geofunc.h
@@ -42,8 +42,160 @@ class Item_geometry_func: public Item_str_func
   const Type_handler *type_handler() const { return &type_handler_geometry; }
 };
 
+
+/*
+  Functions returning REAL measurements of a single GEOMETRY argument
+*/
+class Item_real_func_args_geometry: public Item_real_func
+{
+protected:
+  String value;
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count == 1);
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry);
+  }
+public:
+  Item_real_func_args_geometry(THD *thd, Item *a)
+   :Item_real_func(thd, a) {}
+};
+
+
+/*
+  Functions returning INT measurements of a single GEOMETRY argument
+*/
+class Item_long_func_args_geometry: public Item_long_func
+{
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count == 1);
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry);
+  }
+protected:
+  String value;
+public:
+  Item_long_func_args_geometry(THD *thd, Item *a)
+   :Item_long_func(thd, a) {}
+};
+
+
+/*
+  Functions returning BOOL measurements of a single GEOMETRY argument
+*/
+class Item_bool_func_args_geometry: public Item_bool_func
+{
+protected:
+  String value;
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count == 1);
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry);
+  }
+public:
+  Item_bool_func_args_geometry(THD *thd, Item *a)
+   :Item_bool_func(thd, a) {}
+};
+
+
+/*
+  Functions returning ASCII string measurements of a single GEOMETRY argument
+*/
+class Item_str_ascii_func_args_geometry: public Item_str_ascii_func
+{
+protected:
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 1);
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry);
+  }
+public:
+  Item_str_ascii_func_args_geometry(THD *thd, Item *a)
+   :Item_str_ascii_func(thd, a) {}
+  Item_str_ascii_func_args_geometry(THD *thd, Item *a, Item *b)
+   :Item_str_ascii_func(thd, a, b) {}
+  Item_str_ascii_func_args_geometry(THD *thd, Item *a, Item *b, Item *c)
+   :Item_str_ascii_func(thd, a, b, c) {}
+};
+
+
+/*
+  Functions returning binary string measurements of a single GEOMETRY argument
+*/
+class Item_binary_func_args_geometry: public Item_str_func
+{
+protected:
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 1);
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry);
+  }
+public:
+  Item_binary_func_args_geometry(THD *thd, Item *a)
+   :Item_str_func(thd, a) {}
+};
+
+
+/*
+  Functions returning GEOMETRY measurements of a single GEOEMETRY argument
+*/
+class Item_geometry_func_args_geometry: public Item_geometry_func
+{
+protected:
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 1);
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry);
+  }
+public:
+  Item_geometry_func_args_geometry(THD *thd, Item *a)
+   :Item_geometry_func(thd, a) {}
+  Item_geometry_func_args_geometry(THD *thd, Item *a, Item *b)
+   :Item_geometry_func(thd, a, b) {}
+};
+
+
+/*
+  Functions returning REAL result relationships between two GEOMETRY arguments
+*/
+class Item_real_func_args_geometry_geometry: public Item_real_func
+{
+protected:
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 2);
+    return check_argument_types_or_binary(&type_handler_geometry, 0, 2);
+  }
+public:
+  Item_real_func_args_geometry_geometry(THD *thd, Item *a, Item *b)
+   :Item_real_func(thd, a, b) {}
+};
+
+
+/*
+  Functions returning BOOL result relationships between two GEOMETRY arguments
+*/
+class Item_bool_func_args_geometry_geometry: public Item_bool_func
+{
+protected:
+  String value;
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 2);
+    return check_argument_types_or_binary(&type_handler_geometry, 0, 2);
+  }
+public:
+  Item_bool_func_args_geometry_geometry(THD *thd, Item *a, Item *b, Item *c)
+   :Item_bool_func(thd, a, b, c) {}
+};
+
+
 class Item_func_geometry_from_text: public Item_geometry_func
 {
+  bool check_arguments() const
+  {
+    return args[0]->check_type_general_purpose_string(func_name()) ||
+           check_argument_types_can_return_int(1, MY_MIN(2, arg_count));
+  }
 public:
   Item_func_geometry_from_text(THD *thd, Item *a): Item_geometry_func(thd, a) {}
   Item_func_geometry_from_text(THD *thd, Item *a, Item *srid):
@@ -56,6 +208,11 @@ class Item_func_geometry_from_text: public Item_geometry_func
 
 class Item_func_geometry_from_wkb: public Item_geometry_func
 {
+  bool check_arguments() const
+  {
+    return args[0]->check_type_or_binary(func_name(), &type_handler_geometry) ||
+           check_argument_types_can_return_int(1, MY_MIN(2, arg_count));
+  }
 public:
   Item_func_geometry_from_wkb(THD *thd, Item *a): Item_geometry_func(thd, a) {}
   Item_func_geometry_from_wkb(THD *thd, Item *a, Item *srid):
@@ -70,6 +227,12 @@ class Item_func_geometry_from_wkb: public Item_geometry_func
 class Item_func_geometry_from_json: public Item_geometry_func
 {
   String tmp_js;
+  bool check_arguments() const
+  {
+    // TODO: check with Alexey, for better args[1] and args[2] type control
+    return args[0]->check_type_general_purpose_string(func_name()) ||
+           check_argument_types_traditional_scalar(1, MY_MIN(3, arg_count));
+  }
 public:
   Item_func_geometry_from_json(THD *thd, Item *js): Item_geometry_func(thd, js) {}
   Item_func_geometry_from_json(THD *thd, Item *js, Item *opt):
@@ -83,10 +246,11 @@ class Item_func_geometry_from_json: public Item_geometry_func
 };
 
 
-class Item_func_as_wkt: public Item_str_ascii_func
+class Item_func_as_wkt: public Item_str_ascii_func_args_geometry
 {
 public:
-  Item_func_as_wkt(THD *thd, Item *a): Item_str_ascii_func(thd, a) {}
+  Item_func_as_wkt(THD *thd, Item *a)
+   :Item_str_ascii_func_args_geometry(thd, a) {}
   const char *func_name() const { return "st_astext"; }
   String *val_str_ascii(String *);
   void fix_length_and_dec();
@@ -94,26 +258,41 @@ class Item_func_as_wkt: public Item_str_ascii_func
   { return get_item_copy<Item_func_as_wkt>(thd, mem_root, this); }
 };
 
-class Item_func_as_wkb: public Item_geometry_func
+class Item_func_as_wkb: public Item_binary_func_args_geometry
 {
 public:
-  Item_func_as_wkb(THD *thd, Item *a): Item_geometry_func(thd, a) {}
+  Item_func_as_wkb(THD *thd, Item *a)
+   :Item_binary_func_args_geometry(thd, a) {}
   const char *func_name() const { return "st_aswkb"; }
   String *val_str(String *);
   const Type_handler *type_handler() const { return &type_handler_long_blob; }
+  void fix_length_and_dec()
+  {
+    collation.set(&my_charset_bin);
+    decimals=0;
+    max_length= (uint32) UINT_MAX32;
+    maybe_null= 1;
+  }
   Item *get_copy(THD *thd, MEM_ROOT *mem_root)
   { return get_item_copy<Item_func_as_wkb>(thd, mem_root, this); }
 };
 
 
-class Item_func_as_geojson: public Item_str_ascii_func
+class Item_func_as_geojson: public Item_str_ascii_func_args_geometry
 {
+  bool check_arguments() const
+  {
+    // TODO: check with Alexey, for better args[1] and args[2] type control
+    return Item_str_ascii_func_args_geometry::check_arguments() ||
+           check_argument_types_traditional_scalar(1, MY_MIN(3, arg_count));
+  }
 public:
-  Item_func_as_geojson(THD *thd, Item *js): Item_str_ascii_func(thd, js) {}
-  Item_func_as_geojson(THD *thd, Item *js, Item *max_dec_digits):
-    Item_str_ascii_func(thd, js, max_dec_digits) {}
-  Item_func_as_geojson(THD *thd, Item *js, Item *max_dec_digits, Item *opt):
-    Item_str_ascii_func(thd, js, max_dec_digits, opt) {}
+  Item_func_as_geojson(THD *thd, Item *js)
+   :Item_str_ascii_func_args_geometry(thd, js) {}
+  Item_func_as_geojson(THD *thd, Item *js, Item *max_dec_digits)
+   :Item_str_ascii_func_args_geometry(thd, js, max_dec_digits) {}
+  Item_func_as_geojson(THD *thd, Item *js, Item *max_dec_digits, Item *opt)
+   :Item_str_ascii_func_args_geometry(thd, js, max_dec_digits, opt) {}
   const char *func_name() const { return "st_asgeojson"; }
   void fix_length_and_dec();
   String *val_str_ascii(String *);
@@ -122,10 +301,11 @@ class Item_func_as_geojson: public Item_str_ascii_func
 };
 
 
-class Item_func_geometry_type: public Item_str_ascii_func
+class Item_func_geometry_type: public Item_str_ascii_func_args_geometry
 {
 public:
-  Item_func_geometry_type(THD *thd, Item *a): Item_str_ascii_func(thd, a) {}
+  Item_func_geometry_type(THD *thd, Item *a)
+   :Item_str_ascii_func_args_geometry(thd, a) {}
   String *val_str_ascii(String *);
   const char *func_name() const { return "st_geometrytype"; }
   void fix_length_and_dec() 
@@ -140,7 +320,7 @@ class Item_func_geometry_type: public Item_str_ascii_func
 
 
 // #define HEAVY_CONVEX_HULL
-class Item_func_convexhull: public Item_geometry_func
+class Item_func_convexhull: public Item_geometry_func_args_geometry
 {
   class ch_node: public Gcalc_dyn_list::Item
   {
@@ -163,7 +343,8 @@ class Item_func_convexhull: public Item_geometry_func
   ch_node *new_ch_node() { return (ch_node *) res_heap.new_item(); }
   int add_node_to_line(ch_node **p_cur, int dir, const Gcalc_heap::Info *pi);
 public:
-  Item_func_convexhull(THD *thd, Item *a): Item_geometry_func(thd, a),
+  Item_func_convexhull(THD *thd, Item *a)
+   :Item_geometry_func_args_geometry(thd, a),
     res_heap(8192, sizeof(ch_node))
     {}
   const char *func_name() const { return "st_convexhull"; }
@@ -173,10 +354,11 @@ class Item_func_convexhull: public Item_geometry_func
 };
 
 
-class Item_func_centroid: public Item_geometry_func
+class Item_func_centroid: public Item_geometry_func_args_geometry
 {
 public:
-  Item_func_centroid(THD *thd, Item *a): Item_geometry_func(thd, a) {}
+  Item_func_centroid(THD *thd, Item *a)
+   :Item_geometry_func_args_geometry(thd, a) {}
   const char *func_name() const { return "st_centroid"; }
   String *val_str(String *);
   Field::geometry_type get_geometry_type() const;
@@ -184,10 +366,11 @@ class Item_func_centroid: public Item_geometry_func
   { return get_item_copy<Item_func_centroid>(thd, mem_root, this); }
 };
 
-class Item_func_envelope: public Item_geometry_func
+class Item_func_envelope: public Item_geometry_func_args_geometry
 {
 public:
-  Item_func_envelope(THD *thd, Item *a): Item_geometry_func(thd, a) {}
+  Item_func_envelope(THD *thd, Item *a)
+   :Item_geometry_func_args_geometry(thd, a) {}
   const char *func_name() const { return "st_envelope"; }
   String *val_str(String *);
   Field::geometry_type get_geometry_type() const;
@@ -196,7 +379,7 @@ class Item_func_envelope: public Item_geometry_func
 };
 
 
-class Item_func_boundary: public Item_geometry_func
+class Item_func_boundary: public Item_geometry_func_args_geometry
 {
   class Transporter : public Gcalc_shape_transporter
   {
@@ -221,7 +404,8 @@ class Item_func_boundary: public Item_geometry_func
   };
   Gcalc_result_receiver res_receiver;
 public:
-  Item_func_boundary(THD *thd, Item *a): Item_geometry_func(thd, a) {}
+  Item_func_boundary(THD *thd, Item *a)
+   :Item_geometry_func_args_geometry(thd, a) {}
   const char *func_name() const { return "st_boundary"; }
   String *val_str(String *);
   Item *get_copy(THD *thd, MEM_ROOT *mem_root)
@@ -231,6 +415,8 @@ class Item_func_boundary: public Item_geometry_func
 
 class Item_func_point: public Item_geometry_func
 {
+  bool check_arguments() const
+  { return check_argument_types_can_return_real(0, 2); }
 public:
   Item_func_point(THD *thd, Item *a, Item *b): Item_geometry_func(thd, a, b) {}
   Item_func_point(THD *thd, Item *a, Item *b, Item *srid):
@@ -242,12 +428,12 @@ class Item_func_point: public Item_geometry_func
   { return get_item_copy<Item_func_point>(thd, mem_root, this); }
 };
 
-class Item_func_spatial_decomp: public Item_geometry_func
+class Item_func_spatial_decomp: public Item_geometry_func_args_geometry
 {
   enum Functype decomp_func;
 public:
   Item_func_spatial_decomp(THD *thd, Item *a, Item_func::Functype ft):
-    Item_geometry_func(thd, a) { decomp_func = ft; }
+    Item_geometry_func_args_geometry(thd, a) { decomp_func = ft; }
   const char *func_name() const 
   { 
     switch (decomp_func)
@@ -268,12 +454,19 @@ class Item_func_spatial_decomp: public Item_geometry_func
   { return get_item_copy<Item_func_spatial_decomp>(thd, mem_root, this); }
 };
 
-class Item_func_spatial_decomp_n: public Item_geometry_func
+class Item_func_spatial_decomp_n: public Item_geometry_func_args_geometry
 {
   enum Functype decomp_func_n;
+  bool check_arguments() const
+  {
+    return Item_geometry_func_args_geometry::check_arguments() ||
+           args[1]->check_type_can_return_int(func_name());
+  }
 public:
-  Item_func_spatial_decomp_n(THD *thd, Item *a, Item *b, Item_func::Functype ft):
-    Item_geometry_func(thd, a, b) { decomp_func_n = ft; }
+  Item_func_spatial_decomp_n(THD *thd, Item *a, Item *b, Item_func::Functype ft)
+   :Item_geometry_func_args_geometry(thd, a, b),
+    decomp_func_n(ft)
+  { }
   const char *func_name() const 
   { 
     switch (decomp_func_n)
@@ -296,6 +489,10 @@ class Item_func_spatial_decomp_n: public Item_geometry_func
 
 class Item_func_spatial_collection: public Item_geometry_func
 {
+  bool check_arguments() const
+  {
+    return check_argument_types_or_binary(&type_handler_geometry, 0, arg_count);
+  }
   String tmp_value;
   enum Geometry::wkbType coll_type; 
   enum Geometry::wkbType item_type;
@@ -342,6 +539,11 @@ class Item_func_spatial_rel: public Item_bool_func2_with_rev
   SEL_ARG *get_mm_leaf(RANGE_OPT_PARAM *param, Field *field,
                        KEY_PART *key_part,
                        Item_func::Functype type, Item *value);
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 2);
+    return check_argument_types_or_binary(&type_handler_geometry, 0, 2);
+  }
 public:
   Item_func_spatial_rel(THD *thd, Item *a, Item *b, enum Functype sp_rel):
     Item_bool_func2_with_rev(thd, a, b), spatial_rel(sp_rel)
@@ -392,15 +594,20 @@ class Item_func_spatial_precise_rel: public Item_func_spatial_rel
 };
 
 
-class Item_func_spatial_relate: public Item_bool_func
+class Item_func_spatial_relate: public Item_bool_func_args_geometry_geometry
 {
   Gcalc_heap collector;
   Gcalc_scan_iterator scan_it;
   Gcalc_function func;
   String tmp_value1, tmp_value2, tmp_matrix;
+  bool check_arguments() const
+  {
+    return Item_bool_func_args_geometry_geometry::check_arguments() ||
+           args[2]->check_type_general_purpose_string(func_name());
+  }
 public:
   Item_func_spatial_relate(THD *thd, Item *a, Item *b, Item *matrix):
-    Item_bool_func(thd, a, b, matrix)
+    Item_bool_func_args_geometry_geometry(thd, a, b, matrix)
   { }
   longlong val_int();
   const char *func_name() const { return "st_relate"; }
@@ -416,6 +623,11 @@ class Item_func_spatial_relate: public Item_bool_func
 
 class Item_func_spatial_operation: public Item_geometry_func
 {
+  bool check_arguments() const
+  {
+    DBUG_ASSERT(arg_count >= 2);
+    return check_argument_types_or_binary(&type_handler_geometry, 0, 2);
+  }
 public:
   Gcalc_function::op_type spatial_op;
   Gcalc_heap collector;
@@ -441,8 +653,13 @@ class Item_func_spatial_operation: public Item_geometry_func
 };
 
 
-class Item_func_buffer: public Item_geometry_func
+class Item_func_buffer: public Item_geometry_func_args_geometry
 {
+  bool check_arguments() const
+  {
+    return Item_geometry_func_args_geometry::check_arguments() ||
+           args[1]->check_type_can_return_real(func_name());
+  }
 protected:
   class Transporter : public Gcalc_operation_transporter
   {
@@ -485,8 +702,8 @@ class Item_func_buffer: public Item_geometry_func
   String tmp_value;
 
 public:
-  Item_func_buffer(THD *thd, Item *obj, Item *distance):
-    Item_geometry_func(thd, obj, distance) {}
+  Item_func_buffer(THD *thd, Item *obj, Item *distance)
+   :Item_geometry_func_args_geometry(thd, obj, distance) {}
   const char *func_name() const { return "st_buffer"; }
   String *val_str(String *);
   Item *get_copy(THD *thd, MEM_ROOT *mem_root)
@@ -494,10 +711,11 @@ class Item_func_buffer: public Item_geometry_func
 };
 
 
-class Item_func_isempty: public Item_bool_func
+class Item_func_isempty: public Item_bool_func_args_geometry
 {
 public:
-  Item_func_isempty(THD *thd, Item *a): Item_bool_func(thd, a) {}
+  Item_func_isempty(THD *thd, Item *a)
+   :Item_bool_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_isempty"; }
   void fix_length_and_dec() { maybe_null= 1; }
@@ -506,14 +724,15 @@ class Item_func_isempty: public Item_bool_func
   { return get_item_copy<Item_func_isempty>(thd, mem_root, this); }
 };
 
-class Item_func_issimple: public Item_long_func
+class Item_func_issimple: public Item_long_func_args_geometry
 {
   Gcalc_heap collector;
   Gcalc_function func;
   Gcalc_scan_iterator scan_it;
   String tmp;
 public:
-  Item_func_issimple(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_issimple(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_issimple"; }
   void fix_length_and_dec() { decimals=0; max_length=2; }
@@ -522,10 +741,11 @@ class Item_func_issimple: public Item_long_func
   { return get_item_copy<Item_func_issimple>(thd, mem_root, this); }
 };
 
-class Item_func_isclosed: public Item_long_func
+class Item_func_isclosed: public Item_long_func_args_geometry
 {
 public:
-  Item_func_isclosed(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_isclosed(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_isclosed"; }
   void fix_length_and_dec() { decimals=0; max_length=2; }
@@ -544,11 +764,11 @@ class Item_func_isring: public Item_func_issimple
   { return get_item_copy<Item_func_isring>(thd, mem_root, this); }
 };
 
-class Item_func_dimension: public Item_long_func
+class Item_func_dimension: public Item_long_func_args_geometry
 {
-  String value;
 public:
-  Item_func_dimension(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_dimension(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_dimension"; }
   void fix_length_and_dec() { max_length= 10; maybe_null= 1; }
@@ -556,11 +776,11 @@ class Item_func_dimension: public Item_long_func
   { return get_item_copy<Item_func_dimension>(thd, mem_root, this); }
 };
 
-class Item_func_x: public Item_real_func
+
+class Item_func_x: public Item_real_func_args_geometry
 {
-  String value;
 public:
-  Item_func_x(THD *thd, Item *a): Item_real_func(thd, a) {}
+  Item_func_x(THD *thd, Item *a): Item_real_func_args_geometry(thd, a) {}
   double val_real();
   const char *func_name() const { return "st_x"; }
   void fix_length_and_dec() 
@@ -573,11 +793,10 @@ class Item_func_x: public Item_real_func
 };
 
 
-class Item_func_y: public Item_real_func
+class Item_func_y: public Item_real_func_args_geometry
 {
-  String value;
 public:
-  Item_func_y(THD *thd, Item *a): Item_real_func(thd, a) {}
+  Item_func_y(THD *thd, Item *a): Item_real_func_args_geometry(thd, a) {}
   double val_real();
   const char *func_name() const { return "st_y"; }
   void fix_length_and_dec() 
@@ -590,11 +809,11 @@ class Item_func_y: public Item_real_func
 };
 
 
-class Item_func_numgeometries: public Item_long_func
+class Item_func_numgeometries: public Item_long_func_args_geometry
 {
-  String value;
 public:
-  Item_func_numgeometries(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_numgeometries(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_numgeometries"; }
   void fix_length_and_dec() { max_length= 10; maybe_null= 1; }
@@ -603,11 +822,11 @@ class Item_func_numgeometries: public Item_long_func
 };
 
 
-class Item_func_numinteriorring: public Item_long_func
+class Item_func_numinteriorring: public Item_long_func_args_geometry
 {
-  String value;
 public:
-  Item_func_numinteriorring(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_numinteriorring(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_numinteriorrings"; }
   void fix_length_and_dec() { max_length= 10; maybe_null= 1; }
@@ -616,11 +835,11 @@ class Item_func_numinteriorring: public Item_long_func
 };
 
 
-class Item_func_numpoints: public Item_long_func
+class Item_func_numpoints: public Item_long_func_args_geometry
 {
-  String value;
 public:
-  Item_func_numpoints(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_numpoints(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "st_numpoints"; }
   void fix_length_and_dec() { max_length= 10; maybe_null= 1; }
@@ -629,11 +848,10 @@ class Item_func_numpoints: public Item_long_func
 };
 
 
-class Item_func_area: public Item_real_func
+class Item_func_area: public Item_real_func_args_geometry
 {
-  String value;
 public:
-  Item_func_area(THD *thd, Item *a): Item_real_func(thd, a) {}
+  Item_func_area(THD *thd, Item *a): Item_real_func_args_geometry(thd, a) {}
   double val_real();
   const char *func_name() const { return "st_area"; }
   void fix_length_and_dec() 
@@ -646,11 +864,12 @@ class Item_func_area: public Item_real_func
 };
 
 
-class Item_func_glength: public Item_real_func
+class Item_func_glength: public Item_real_func_args_geometry
 {
   String value;
 public:
-  Item_func_glength(THD *thd, Item *a): Item_real_func(thd, a) {}
+  Item_func_glength(THD *thd, Item *a)
+   :Item_real_func_args_geometry(thd, a) {}
   double val_real();
   const char *func_name() const { return "st_length"; }
   void fix_length_and_dec() 
@@ -663,11 +882,11 @@ class Item_func_glength: public Item_real_func
 };
 
 
-class Item_func_srid: public Item_long_func
+class Item_func_srid: public Item_long_func_args_geometry
 {
-  String value;
 public:
-  Item_func_srid(THD *thd, Item *a): Item_long_func(thd, a) {}
+  Item_func_srid(THD *thd, Item *a)
+   :Item_long_func_args_geometry(thd, a) {}
   longlong val_int();
   const char *func_name() const { return "srid"; }
   void fix_length_and_dec() { max_length= 10; maybe_null= 1; }
@@ -676,7 +895,7 @@ class Item_func_srid: public Item_long_func
 };
 
 
-class Item_func_distance: public Item_real_func
+class Item_func_distance: public Item_real_func_args_geometry_geometry
 {
   String tmp_value1;
   String tmp_value2;
@@ -684,7 +903,8 @@ class Item_func_distance: public Item_real_func
   Gcalc_function func;
   Gcalc_scan_iterator scan_it;
 public:
-  Item_func_distance(THD *thd, Item *a, Item *b): Item_real_func(thd, a, b) {}
+  Item_func_distance(THD *thd, Item *a, Item *b)
+   :Item_real_func_args_geometry_geometry(thd, a, b) {}
   double val_real();
   const char *func_name() const { return "st_distance"; }
   Item *get_copy(THD *thd, MEM_ROOT *mem_root)
@@ -692,14 +912,15 @@ class Item_func_distance: public Item_real_func
 };
 
 
-class Item_func_pointonsurface: public Item_geometry_func
+class Item_func_pointonsurface: public Item_geometry_func_args_geometry
 {
   String tmp_value;
   Gcalc_heap collector;
   Gcalc_function func;
   Gcalc_scan_iterator scan_it;
 public:
-  Item_func_pointonsurface(THD *thd, Item *a): Item_geometry_func(thd, a) {}
+  Item_func_pointonsurface(THD *thd, Item *a)
+   :Item_geometry_func_args_geometry(thd, a) {}
   const char *func_name() const { return "st_pointonsurface"; }
   String *val_str(String *);
   Field::geometry_type get_geometry_type() const;
diff --git a/sql/sql_type.h b/sql/sql_type.h
index c377f26..48b0699 100644
--- a/sql/sql_type.h
+++ b/sql/sql_type.h
@@ -658,6 +658,10 @@ class Type_handler
   {
     return true;
   }
+  virtual bool is_scalar_type() const { return true; }
+  virtual bool can_return_int() const { return true; }
+  virtual bool can_return_real() const { return true; }
+  virtual bool is_general_purpose_string_type() const { return false; }
   virtual uint Item_time_precision(Item *item) const;
   virtual uint Item_datetime_precision(Item *item) const;
   virtual uint Item_decimal_scale(const Item *item) const;
@@ -944,6 +948,9 @@ class Type_handler_row: public Type_handler
 public:
   virtual ~Type_handler_row() {}
   const Name name() const { return m_name_row; }
+  bool is_scalar_type() const { return false; }
+  bool can_return_int() const { return false; }
+  bool can_return_real() const { return false; }
   enum_field_types field_type() const
   {
     DBUG_ASSERT(0);
@@ -1660,6 +1667,13 @@ class Type_handler_string_result: public Type_handler
 };
 
 
+class Type_handler_general_purpose_string: public Type_handler_string_result
+{
+public:
+  bool is_general_purpose_string_type() const { return true; }
+};
+
+
 /***
   Instantiable classes for every MYSQL_TYPE_XXX
 
@@ -2312,7 +2326,7 @@ class Type_handler_newdecimal: public Type_handler_decimal_result
 };
 
 
-class Type_handler_null: public Type_handler_string_result
+class Type_handler_null: public Type_handler_general_purpose_string
 {
   static const Name m_name_null;
 public:
@@ -2350,7 +2364,7 @@ class Type_handler_null: public Type_handler_string_result
 };
 
 
-class Type_handler_longstr: public Type_handler_string_result
+class Type_handler_longstr: public Type_handler_general_purpose_string
 {
 public:
   bool type_can_have_key_part() const
@@ -2582,6 +2596,8 @@ class Type_handler_geometry: public Type_handler_string_result
                           const Type_all_attributes &attr,
                           TABLE *table) const;
 
+  bool can_return_int() const { return false; }
+  bool can_return_real() const { return false; }
   bool is_traditional_type() const
   {
     return false;
@@ -2613,7 +2629,7 @@ extern MYSQL_PLUGIN_IMPORT Type_handler_geometry type_handler_geometry;
 #endif
 
 
-class Type_handler_typelib: public Type_handler_string_result
+class Type_handler_typelib: public Type_handler_general_purpose_string
 {
 public:
   virtual ~Type_handler_typelib() { }
